// PSF.c      Point Spread Function for CT    2013.11.07
// CTFBP.c    FBP for CT   729x180            2013.11.05
// PETFBP.c   FBP for PET  256x128x87

#include "HU.h"

void Main(void)
{
	char		f[300], s[100], buf[10], yn, a, b, recon;
	int			bw;
	int			i,j,c,ii,jj,ir,jr,RJ,T,MAXT,px,py,px2,py2, cutoff,xp,yp,ip,ip2,jp,jp2, Width, Center;
	
	double		data, max, min, maxp, maxp0, minp, maxpth;
	double 		PAI, dT, I, J, rot, gh, Filter[300];
	
	long		OFFSET;
	
	static double	y[729][181], Proj[260][260][181], Pth[260][260][181], CT[256][256];
	static double	Back_Proj[260][260], Filtered_Sino[260][260], Sino[260][260], Filtered_Proj[260][260];
	
	FILE *fp;
		
	TextWindow(2,20,350,600);	Title("CT FBP");  printf("CT BackProjection");

 	
//------------------- Create Point Image Projection -----------------------------

    START:  
	
	for(j=0;j<=180;j++){ for(i=0;i<256;i++){ Sino[i][j] = 0.0; }}
	
	for(j=0;j<=181;j++){ Sino[128][j] = 10.0; }



//------------------- Disp sinogram ----------------------------------------------

	max = min = y[0][0];

	for(j=0; j<180; j++){ for(i=0; i<256; i++){
		
		data = Sino[i][j];  if(data>max)max=data; if(data<min)min=data;
 
	}}	
	printf("\n\n max count = %lf",max); printf("\n min count = %lf",min);


GraphicWindow(1200,800,BK_BLACK);

	for(j=0;j<180;j++){ for(i=0;i<256;i++){

	    data = Sino[i][j]; 
		
		bw = (int)( (data-min) * 255. / (max-min)  ); 
		
		if(bw>255)bw=255; if(bw<0)bw=0;

		SetColor( RGB(bw,bw,bw) ); SetPixel(i+10,j+10);
	}} 

//------------------- Select Reconstruction method -----------------------

	printf("\n\n Select Reconstruction method ");
	printf("\n\n 1: Simple BackProjection \n 2: Filtered BackProjection ");
	
	printf("\n "); scanf("%c",&recon); 

	if(recon=='1')goto BACK_PROJECTION;

//------------------- Load Real space filter -----------------------

SELECT_FILTER:

	printf("\n\n Load Real space Filter "); scanf("%c",&yn);
	 
	GetFileName( f, 0);   fp = fopen( f, "rt");

	for(i=0; i<128; i++){ fscanf( fp, "%lf \n", Filter+i); }
	
	fclose(fp);

//------------------ Display Real space filter ---------------------
	
	SetColor(BLACK);Rect(500,130,750,400,1);
	PenWidth(4);  SetColor(WHITE); FontSize(22); DrawString(650, 70, "Real Space Filter" );
	
	SetColor(YELLOW);

	
	for(i=0; i<20; i++){  

		px = 600 + i*5 ;  px2 = 600 + (i+1)*5 ;
		py = 300 - (int)( 4.0 * Filter[i]);  py2 = 300 - (int)( 4.0 * Filter[i+1]); 
		Line( px, py, px2, py2 );
		
		px = 600 - i*5 ;  px2 = 600 - (i+1)*5 ;
		py = 300 - (int)( 4.0 * Filter[i]);  py2 = 300 - (int)( 4.0 * Filter[i+1]); 
		Line( px, py, px2, py2 );
	}
	Flush(); PenWidth(1); 
	
	printf("\n\n Real space filter = \n\n %s \n OK ? (yes; enter, no; n ) ", f ); scanf("%c", &yn);
	if(yn=='n' || yn=='N')goto SELECT_FILTER;

//---------------------- Generate Filtered Pth (P) data ------------------------------------------
		
	BACK_PROJECTION:
	
	MAXT=180;  	PAI = 3.141592653589793/180.0;   dT = 1.0;

	for(T=0;T<MAXT;T++){for(j=0;j<256;j++){for(i=0;i<256;i++){Pth[i][j][T]=-1.0;}}}
	
	
	for(T=0; T<MAXT;T++){ 

		
		if(recon=='1'){
		
			///////////////////  Simple Back Projection  ////////////////////////////

			for(i=0; i<256; i++){  Filtered_Sino[i][T] = Sino[i][T];  }
	   
		}		
		
		if(recon!='1'){
		
			///////////////////  Filtered Back Projection  ////////////////////////////

			//------------------ Convolution Filter[] into Sino[]  ---------------------
		
			for(i=0; i<256; i++){
	
				gh = 0.0 ;
		
				for(j=0; j<=127; j++){ if( i+j < 256 ) gh += (double)Sino[i+j][T] * Filter[j]; }
		
				for(j=1; j<=127; j++){ if( i-j >= 0 )  gh += (double)Sino[i-j][T] * Filter[j]; }

				Filtered_Sino[i][T] = (float)gh ; 
			}
	   
			////////////////////////////////////////////////////////////////////////////
		}

	
	for(j=0;j<256;j++){for(i=0;i<256;i++){ Filtered_Proj[i][j] = Filtered_Sino[i][T]; }} 


	rot = (double)T * dT * PAI ; 
		
		for(j=0;j<256;j++){for(i=0;i<256;i++){  I=(double)i;  J=(double)j;
		
			ir=(int)(( I-127.5 )*cos(rot) - ( J-127.5 )*sin(rot) + 127.5 + 0.5);
			jr=(int)(( I-127.5 )*sin(rot) + ( J-127.5 )*cos(rot) + 127.5 + 0.5);
		
			if(ir>=0 && ir<256 && jr>=0 && jr<256)Pth[ir][jr][T]=Filtered_Proj[i][j];
		}}
	}

	for(T=0; T<MAXT;T++){ 
	
		for(j=1;j<255;j++){for(i=1;i<255;i++){
	
		if(Pth[i][j][T]==-1. && Pth[i-1][j][T]!=-1. && Pth[i+1][j][T]!=-1.)Pth[i][j][T]=(Pth[i-1][j][T]+Pth[i+1][j][T])/2.;
		if(Pth[i][j][T]==-1. && Pth[i][j-1][T]!=-1. && Pth[i][j+1][T]!=-1.)Pth[i][j][T]=(Pth[i][j-1][T]+Pth[i][j+1][T])/2.;
		}}

		for(j=0;j<256;j++){for(i=0;i<256;i++){if(Pth[i][j][T]==-1.)Pth[i][j][T]=0.; }}
	}

//---------------------- Disp Projection Pth-----------------------------------------------------------------

	maxpth=0.; for(j=0;j<256;j++){ for(i=0;i<256;i++){ if(Pth[i][j][1]>maxpth)maxpth=Pth[i][j][1]; }}

	Flush();		
	for(T=0; T<MAXT; T+=5){ 
	
		px=128*(T/5-10*(T/5/10));  	py=200+128*(T/50); 	

		for(j=0;j<256;j+=2){ for(i=0;i<256;i+=2){ 

			c = (int)(Pth[i][255-j][T] * 255./maxpth) ; if(c>255)c=255; 

			SetColor(RGB(c,c,c));  if(c<0)SetColor(SKYBLUE);  SetPixel(i/2+px,j/2+py);
		}}
	}

	Flush(); printf("\n\n Disp Filtered Pth * Filter ");scanf("%c",&yn); 

//------------------------- BackProjection --------------------------------------------

	for(j=0;j<256;j++){ for(i=0;i<256;i++){ Back_Proj[i][j] = 0.; }}

	for(T=0;T<181;T++){ for(j=0;j<256;j++){ for(i=0;i<256;i++){ 
		
		Back_Proj[i][j] += Pth[i][j][T]; 
	}}}

//---------------------- Disp Filtered BackProjection ----------------------------------
	ClearWindow();

	maxp=minp=Back_Proj[0][0];
	
	for(j=0;j<256;j++){ for(i=0;i<256;i++){ 
		
		if(Back_Proj[i][j]>maxp)maxp=Back_Proj[i][j]; if(Back_Proj[i][j]<minp)minp=Back_Proj[i][j]; 
	}}
	printf("\n\n maxp count = %lf",maxp); printf("\n minp count = %lf",minp);
	
	maxp/=50.0;  maxp0 = maxp;

	Flush();
	for(j=0;j<256;j++){ for(i=0;i<256;i++){ 	
		
		data = Back_Proj[i][255-j] * 255./maxp;  CT[i][j] = data; 
		
		bw = (int)data; if(bw>255)bw=255; 

		for(ii=0;ii<=1;ii++){ for(jj=0;jj<=1;jj++){
			
			SetColor(RGB(bw,bw,bw));  if(bw<0)SetColor(SKYBLUE); SetPixel(2*i+ii,2*j+jj);
		}}
	}}
	SetColor(YELLOW);PenWidth(2); 
	Line(0, 255, 250, 255); Line(263, 255, 511, 255);
	Line(255, 0, 255, 250); Line(255, 263, 255, 511);
	Line(520, 255, 520+512, 255);

	SetColor(WHITE);PenWidth(3);
	for(i=0; i<255; i++){
	
		ip = 2*i+520 ;  ip2 = 2*(i+1)+520;

		jp  = 256 - (int)(Back_Proj[i][128]*5./maxp);  jp2 = 256 - (int)(Back_Proj[i+1][128]*5./maxp);  

		Line( ip, jp, ip2, jp2 );
	}	
	PenWidth(1);
//---------------------- Disp BackProjection Process ----------------------------------

	printf("\n\n Disp FBP Process? \n(yes:enter, no:n) ");scanf("%c",&yn); 
	if(yn=='n' || yn=='N')goto HU_WINDOW;
	
	ClearWindow();

	for(j=0;j<256;j++){ for(i=0;i<256;i++){ Back_Proj[i][j] = 0.; }}

	
	//SetColor(YELLOW); FontSize(28); PenWidth(3);
		
	
	for(T=0;T<181;T++){ Event(); //printf("\n T = %d", T); //scanf("%c",&yn); 
		
		
		for(j=0;j<256;j++){ for(i=0;i<256;i++){ 
			 
			Back_Proj[i][j] += Pth[i][j][T]; 
		}}
	
	
	maxp=Back_Proj[0][0];
	
	for(j=0;j<256;j++){ for(i=0;i<256;i++){ 
		
		if(Back_Proj[i][j]>maxp)maxp=Back_Proj[i][j];  
	}}
	
	maxp/=20.0;
	
	Flush();

	if( 10*(int)((T)/5) !=(int)( 10.0*(double)(T)/5.0 ) )goto NEXT_T;

	for(j=0;j<256;j++){ for(i=0;i<256;i++){ 	
		
		data = Back_Proj[i][255-j] * 255./maxp; 
		
		bw = (int)data; if(bw>255)bw=255;  

		for(ii=0;ii<=1;ii++){ for(jj=0;jj<=1;jj++){
			
			SetColor(RGB(bw,bw,bw));  if(bw<0)SetColor(SKYBLUE); SetPixel(2*i+ii,2*j+jj);
		}}
	}}
	
	for(j=0;j<256;j++){ for(i=0;i<256;i++){ 	
		
		data = Pth[i][255-j][T] * 255./maxpth;  
		
		bw = (int)data; if(bw>255)bw=255;  

		for(ii=0;ii<=1;ii++){ for(jj=0;jj<=1;jj++){
			
			SetColor(RGB(bw,bw,bw));  if(bw<0)SetColor(SKYBLUE); SetPixel(2*i+ii+520,2*j+jj);
		}}
	}}
	
	SetColor(YELLOW); FontSize(28); PenWidth(3);
	strcpy(s,"Sum Image of P*h from = 0 to "); _gcvt((double)T,5,buf); strcat(s, buf); DrawString(10, 1, s );
	strcpy(s,"P*h of = "); _gcvt((double)T,5,buf); strcat(s, buf); DrawString(700, 1, s );


NEXT_T:;

	} //T

	SetColor(YELLOW);PenWidth(2); Line(520, 255, 520+512, 255);
	
	SetColor(WHITE);PenWidth(3);

	for(i=0; i<255; i++){
	
		ip = 2*i+520 ;  ip2 = 2*(i+1)+520;

		jp  = 256 - (int)(Back_Proj[i][128]*5./maxp0);  jp2 = 256 - (int)(Back_Proj[i+1][128]*5./maxp0);  

		Line( ip, jp, ip2, jp2 );
	}	
	PenWidth(1);
//---------------------- Change HU Center & Width ----------------------------------
HU_WINDOW:

	printf("\n HU Center = "); scanf("%d",&Center); 
	printf("\n HU Width  = "); scanf("%d",&Width); 
	
	max = (double)(Center+Width/2);  min = (double)(Center-Width/2);
	
	Flush();
	
	
	for(j=0;j<256;j++){ for(i=0;i<256;i++){ 	

		data = CT[i][j];  
		
        	bw = (int)( (data-min) * 255. / (max-min) ); if(bw>255)bw=255; if(bw<0)bw=0; 

		for(ii=0;ii<=1;ii++){ for(jj=0;jj<=1;jj++){
			
			SetColor(RGB(bw,bw,bw));  SetPixel(2*i+ii,2*j+jj+140);
		}}
	}}

	printf("\n\n Retry HU Center, Window ? (no:n) ");scanf("%c",&yn); if(yn!='n')goto HU_WINDOW;
	

//------------------- End -------------------------------
	
	printf("\n\n Retry? (no:n) ");scanf("%c",&yn); if(yn!='n')goto START;	
	exit(0);
}
